using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace store_starter
{
	/// <summary>
	/// Summary description for Cart.
	/// </summary>
	public class Cart : System.Web.UI.Page, IStorePage {
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.Repeater itemsRepeater;
		protected System.Web.UI.WebControls.PlaceHolder noItems;
		#endregion
		
		protected StoreContext storeContext;

		private void Page_Load(object sender, System.EventArgs e) {
			// initialize class variables
			storeContext = new StoreContext(this);

			// if user is not logged in, refer to login page
			if(!storeContext.UserLoggedIn){
				Response.Redirect("Login.aspx?Action=Login&Return=" + Request.Url);
			}

			// load cart data unless page is post back (we don't want to write over quantity updates)
			if(!Page.IsPostBack){
				LoadData();
			}
		}

		/// <summary>
		/// load data from database into form
		/// </summary>
		private void LoadData(){

			if(true/* if there are no items in cart */){
				noItems.Visible = true;
				itemsRepeater.Visible = false;
			}
			
			DataBind();
			
		}

		/// <summary>
		/// Get the context object for this page.
		/// </summary>
		public StoreContext StoreContext{
			get {
				return storeContext;
			}
		}

		/// <summary>
		/// Handle checkout button clicked
		/// </summary>
		public void CheckOut(object sender, System.EventArgs e){
			throw new ApplicationException("Check out not yet implemented");
		}

		/// <summary>
		/// Handle update quantities button click
		/// </summary>
		public void UpdateQuantities(object sender, System.EventArgs e){
			// if form is valid ...
			if(Page.IsValid){
				try{
					// foreach item in the repeater ... update its quantity or remove it from the cart
					foreach(RepeaterItem item in itemsRepeater.Items){
						// find controls in repeater item for information
						// find hidden textbox that holds ID
						TextBox productIDTxtbox = (TextBox)item.FindControl("productID");
						// find quantity textbox
						TextBox quantityTxtbox = (TextBox)item.FindControl("quantity");

						int productID = Int32.Parse(productIDTxtbox.Text);
						int quantity = Int32.Parse(quantityTxtbox.Text);

						/* update or remove cart items */
					}
				} catch (Exception ex){
					/* better recover as best possible */
					throw ex;				
				}
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
