using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace store_starter {
	/// <summary>
	/// Login page for users to log in and out
	/// </summary>
	public class Login : System.Web.UI.Page, IStorePage {
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.TextBox email;
		protected System.Web.UI.WebControls.TextBox password;
		protected System.Web.UI.WebControls.CheckBox savepassword;
		protected System.Web.UI.WebControls.Button loginbutton;
		protected System.Web.UI.WebControls.PlaceHolder logoutMessage;
		protected System.Web.UI.WebControls.PlaceHolder loginError;
		protected System.Web.UI.WebControls.PlaceHolder loginForm;
		protected System.Web.UI.WebControls.PlaceHolder metarefresh;
		protected System.Web.UI.WebControls.PlaceHolder loginMessage;
		protected System.Web.UI.WebControls.RequiredFieldValidator email_val2;
		protected System.Web.UI.WebControls.RequiredFieldValidator password_val2;
		#endregion

		
		private StoreContext storeContext;
	
		private void Page_Load(object sender, System.EventArgs e) {

			storeContext = new StoreContext(this);

			// if page is posting back then it will be handled by a button event handler
			if(!Page.IsPostBack){
				// get querystring data
				string action = Request.QueryString["Action"];

				switch (action){
					case "Login":
						// do nothing
						break;
					case "Logout":
						// log user out and delete cookies if they have them
						HttpCookie login = Request.Cookies["storeLogin"];
						HttpCookie pass = Request.Cookies["storePassword"];
						if(login != null){
							// to delete a cookie, set its expiration time for two days ago
							login.Expires = DateTime.Now.AddDays(-2);
							pass.Expires = DateTime.Now.AddDays(-2);
							Response.Cookies.Add(login);
							Response.Cookies.Add(pass);
						}
						
						// log user out of session in storeContext
						storeContext.UserLogout();
						metarefresh.Visible = true;
						break;
					default:
						Response.Redirect("Default.aspx");
						break;
				}
			}

			DataBind();
		}

		/// <summary>
		/// Get the context object for this page.
		/// </summary>
		public StoreContext StoreContext{
			get {
				return storeContext;
			}
		}

		/// <summary>
		/// Handle Login button click!
		/// </summary>
		public void GoLogin(object sedner, System.EventArgs e){
			// check validators to make sure form is valid
			if(Page.IsValid){

				// check datbase to see if user has correct password
				string userEmail = "";
				string userPassword = "";
				int userID = 0;

				if(true/*if record not reutned from database*/){
					// login failed! =(
					loginError.Visible = true;
					return;
				} else {

					// if the saved their password, then set cookies
					if(this.savepassword.Checked){
						Response.Cookies.Add(new HttpCookie("storeLogin",userEmail));
						// store password in cookie in cleartext, big fat no no, but for the purposes of this project, oh well.
						// if you want to learn how to use encryption, more power to you. (System.Security.Cryptography)
						Response.Cookies.Add(new HttpCookie("storePassword",userPassword));
					}

					// do session login stuff in storeContext
					storeContext.UserLogin(userEmail, userID);
				
					// show succesful login message
					metarefresh.Visible = true;
					loginMessage.Visible = true;
					loginForm.Visible = false;
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}

