using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace store_starter
{
	/// <summary>
	/// The order page displays the summy of an invoice/order
	/// </summary>
	public class Order : System.Web.UI.Page, IStorePage {
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.PlaceHolder inputError;
		protected System.Web.UI.WebControls.Repeater itemRepeater;
		protected System.Web.UI.WebControls.PlaceHolder invoiceContent;
		protected System.Web.UI.WebControls.Repeater packageRepeater;
		#endregion
		
		private StoreContext storeContext;

		private void Page_Load(object sender, System.EventArgs e) {
			storeContext = new StoreContext(this);

			// if user is not logged in, refer to login page
			if(!storeContext.UserLoggedIn){
				Response.Redirect("Login.aspx?Return=" + Page.Request.Url);
			}

			// initialize class varialbes
			int invoiceID = 0;
			inputError.Visible = false;
			invoiceContent.Visible = true;

			// check the querystring invoice id for validity
			try {
				invoiceID = Int32.Parse(Request.QueryString["invoice"]);
			} catch (FormatException) {
				// if querystring value is invalid, show error message
				inputError.Visible = true;
				invoiceContent.Visible = false;
				return;
			}

			// get the invoice information from the database

			if(true/*if no results were returned, show error*/){
				invoiceContent.Visible = false;
				inputError.Visible = true;
			}

			DataBind();

		}

		/// <summary>
		/// Get the context object for this page.
		/// </summary>
		public StoreContext StoreContext{
			get {
				return storeContext;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
