using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace store_starter {
	/// <summary>
	/// The product page shows the product details
	/// </summary>
	public class Product : System.Web.UI.Page, IStorePage {
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.PlaceHolder InputError;
		protected System.Web.UI.WebControls.Repeater authorRepeater;
		protected System.Web.UI.WebControls.PlaceHolder MainContent;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.PlaceHolder outOfStock;
		#endregion
	
		private StoreContext storeContext;
		private int productID;

		private void Page_Load(object sender, System.EventArgs e) {

			// initialize class varaibles
			storeContext = new StoreContext(this);

			productID = 0;
			InputError.Visible = false;
			MainContent.Visible = true;

			// check querystring product ID value for validity
			try {
				productID = Int32.Parse(Request.QueryString["product"]);
			} catch (FormatException ) {
				// if the querystring value is invalid, display an error
				InputError.Visible = true;
				MainContent.Visible = false;
				return;
			}

			// go ge the data ....			
			
			DataBind();
		}

		/// <summary>
		/// Get the context object for this page.
		/// </summary>
		public StoreContext StoreContext{
			get {
				return storeContext;
			}
		}

		/// <summary>
		/// Respond to the "Add to Cart" button click
		/// </summary>
		public void AddToCart(object sender, System.EventArgs e){
			// if user isn't logged in, send them to the login page
			if(!storeContext.UserLoggedIn){
				Response.Redirect("Login.aspx?Return=" + Page.Request.Url);
			}
			
			// add to cart

			// check to see if item is in cart

			if(false/*if in cart*/){
				// if not, add it
			} else {
				// if so, increase quantity
			}

			// forward user to cart page so they can see their newly added item.
			Response.Redirect("Cart.aspx");

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
