using System;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace store_starter {

	/// <summary>
	///	A small user control to provide a consistant navigation bar and search bar fot he store
	/// </summary>
	public class SideMenu : System.Web.UI.UserControl {
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.TextBox searchbox;
		protected System.Web.UI.WebControls.DropDownList searchtype;
		protected System.Web.UI.WebControls.DropDownList searchby;
		protected System.Web.UI.WebControls.Button searchbutton;
		#endregion

		/// <summary>
		/// Method that is always called 
		/// </summary>
		private void Page_Load(object sender, System.EventArgs e) {

			// check query string for search params to prepopulate search 
			string keywords = Request.QueryString["Keywords"];
			string search = Request.QueryString["Search"];
			string view = Request.QueryString["View"];
			
			// if the page is currently a search page ...
			if(!Page.IsPostBack && keywords != null){
				// populate the search form with the values represented in the querystring
				searchbox.Text = keywords;
				
				switch (search){
					case "Title":
						searchby.SelectedIndex = 1;
						break;
					case "Author":
						searchby.SelectedIndex = 2;
						break;
				}
				switch (view){
					case "Books":
						searchtype.SelectedIndex = 1;
						break;
					case "Music":
						searchtype.SelectedIndex = 2;
						break;
				}
			}
		}

		/// <summary>
		/// Respond to the search button clicked
		/// </summary>
		private void Search(object sender, System.EventArgs e) {
			// redirect to a page with the serach results
			Response.Redirect("Products.aspx?View=" + searchtype.SelectedValue + "&Search=" + searchby.SelectedValue + "&Keywords=" + searchbox.Text);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.searchbutton.Click += new System.EventHandler(this.Search);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
